﻿using UnityEngine;
using System.Collections;

public class DestroyByContact : MonoBehaviour {

    public int scoreValue;
    private GameController gameController;

    //visual effects
    public GameObject birdSplat;
    public GameObject balloonExplosion;
    

    void Start()
    {
        GameObject gameControllerObject = GameObject.FindWithTag("GameController");
        if (gameControllerObject != null)
        {
            gameController = gameControllerObject.GetComponent<GameController>();
        }
        if (gameControllerObject == null)
        {
            Debug.Log("Cannot find 'GameController' script");
        }
    }

    void OnTriggerEnter(Collider other)
    {
        //objects are destroyed upon leaving the boundary, not entering it
        if (other.tag == "Boundary")
        {
            return;
        }

        //destroyable hazards destroyed by a bullet give points
        if (gameObject.tag.Contains("Hazard") && other.gameObject.tag == "Bullet")
        { 
            if (gameObject.tag.Contains("Points")) {
                gameController.AddScore(scoreValue);
                Destroy(other.gameObject);
                Destroy(gameObject);
                Instantiate(birdSplat, transform.position, transform.rotation);
            }
            return;
        }

        //hazards cannot destroy each other
        if (gameObject.tag.Contains("Hazard") && other.gameObject.tag.Contains("Hazard"))
        {
            return;
        }

        //
        if (gameObject.tag == "Player" && other.tag.Contains("Hazard"))
        {
            if (!other.tag.Contains("Points"))
            {
                gameController.lives = 0;
                gameController.GameOver();
                Destroy(gameObject);
                Instantiate(balloonExplosion, transform.position, transform.rotation);
            }
            else
            {
                if (gameController.lives > 1)
                {
                    gameController.lives -= 1;
                    StartCoroutine(gameController.hitLine());
                }
                else
                {
                    gameController.lives = 0;
                    gameController.GameOver();
                    Destroy(gameObject);
                    Instantiate(balloonExplosion, transform.position, transform.rotation);
                }
            }
        }
    }
}
