﻿using UnityEngine;
using System.Collections;

public class Homing : MonoBehaviour {

    public float flyingSpeed;

    private Transform target;
    private float birdTurnSpeed;
    private float randomOffset;

    void Start()
    {
        GameObject p = GameObject.FindGameObjectWithTag("Player"); //set player as homing target 
        if (p != null) { 
            target = p.transform;
            birdTurnSpeed = 360.0f; //rocket turns directly to target from spawn
            randomOffset = 0.0f;
        } else
        {
            Debug.Log("Cannot find target with tag 'player'");
        }         
    }

    void Update()
    {
        if (target != null)
        {
            //turnSpeed increases when the rocket gets closer to the target
            if ((target.position - transform.position).magnitude > 50)
            {
                randomOffset = 100.0f;
                birdTurnSpeed = 90.0f;
            }
            else
            {
                randomOffset = 5f;
                if ((target.position - transform.position).magnitude < 10)
                {
                    birdTurnSpeed = 180.0f;
                }
            }

            //creates random wiggle
            Vector3 direction = target.position - transform.position+ Random.insideUnitSphere * randomOffset;
            direction.Normalize();
            transform.rotation = Quaternion.RotateTowards(transform.rotation, Quaternion.LookRotation(direction), birdTurnSpeed * Time.deltaTime);
            transform.Translate(Vector3.forward * flyingSpeed * Time.deltaTime);
        }
        else
        {
            //When target is destroyed, fly to infinity until boundary is hit
            Vector3 direction = transform.position;
            transform.rotation = Quaternion.RotateTowards(transform.rotation, Quaternion.LookRotation(direction), birdTurnSpeed * Time.deltaTime);
            transform.Translate(Vector3.forward * flyingSpeed * Time.deltaTime);
            return;
        }
    }
}
