﻿using UnityEngine;
using System.Collections;
using UnityEngine.SceneManagement;

public class TitleController : MonoBehaviour {

    public GUIText pressKeyText;
    public GUIText highScoreText;
    public GUIText controlText;


    /*
     * Fetch current highscore, start the text flash coroutine and play background music
     */
	void Start () {
        fetchAndDisplayHighScore();
        StartCoroutine(textFlash());
        GetComponent<AudioSource>().Play();
        controlText.text = "Movement: W (up) A (left) D (right) \n Shooting: mouse (aim) LMB (shoot)";
	}

    /*
     * Check if any key is pressed, then continue to the main game
     */
    void Update()
    {
        if (Input.GetKeyDown(KeyCode.Alpha1))
        {
            System.IO.File.WriteAllText("Assets/Other/PlayerCount.txt", "" + 1);
            SceneManager.LoadScene("Main");
        } else if (Input.GetKeyDown(KeyCode.Alpha2)) {
            System.IO.File.WriteAllText("Assets/Other/PlayerCount.txt", "" + 2);
            SceneManager.LoadScene("Main");
        }
    }
	
    /*
     * Routine to flash the start indication text
     */
	private IEnumerator textFlash()
    {
        while(true) {
            pressKeyText.text = "";
            yield return new WaitForSeconds(0.5f);
            pressKeyText.text = "PRESS 1 FOR SINGLE PLAYER \n PRESS 2 FOR CO-OP";
            yield return new WaitForSeconds(1f);
        }   
    }

    /*
     * Fetches highscore from the text file and display it on screen
     */
    private void fetchAndDisplayHighScore()
    {
        highScoreText.text = "Current Best: " + System.IO.File.ReadAllText("Assets/Other/HighScore.txt");
    }
}
